#ifndef __GO_M8010_6_H
#define __GO_M8010_6_H

#include "struct_typedef.h"
#pragma pack(1)
/**
 * @brief ģʽϢ
 *
 */
typedef struct
{
    uint8_t id : 4;      // ID: 0,1...,13,14 15ʾе㲥(ʱ޷)
    uint8_t status : 3;  // ģʽ: 0. 1.FOCջ 2.У׼ 3.
    uint8_t reserve : 1; // λ
} RIS_Mode_t;            // ģʽ 1Byte

/**
 * @brief ״̬Ϣ
 *
 */
typedef struct
{
    int16_t tor_des; // ؽŤ unit: N.m      (q8)
    int16_t spd_des; // ؽٶ unit: rad/s    (q8)
    int32_t pos_des; // ؽλ unit: rad      (q15)
    int16_t k_pos;   // ؽڸնϵ unit: -1.0-1.0 (q15)
    int16_t k_spd;   // ؽϵ unit: -1.0-1.0 (q15)

} RIS_Comd_t; // Ʋ 12Byte

/**
 * @brief ״̬Ϣ
 *
 */
typedef struct
{
    int16_t torque;      // ʵʹؽŤ unit: N.m     (q8)
    int16_t speed;       // ʵʹؽٶ unit: rad/s   (q8)
    int32_t pos;         // ʵʹؽλ unit: rad     (q15)
    int8_t temp;         // ¶: -128~127C
    uint8_t MError : 3;  // ʶ: 0. 1. 2. 3.ѹ 4. 5-7.
    uint16_t force : 12; // ѹ 12bit (0-4095)
    uint8_t none : 1;    // λ
} RIS_Fbk_t;             // ״̬ 11Byte

/**
 * @brief ݰʽ
 *
 */
typedef struct
{
    uint8_t head[2]; // ͷ         2Byte
    RIS_Mode_t mode; // ģʽ  1Byte
    RIS_Comd_t comd; //  12Byte
    uint16_t CRC16;  // CRC          2Byte

} RIS_ControlData_t; //      17Byte

/**
 * @brief ݰʽ
 *
 */
typedef struct
{
    uint8_t head[2]; // ͷ         2Byte
    RIS_Mode_t mode; // ģʽ  1Byte
    RIS_Fbk_t fbk;   //  11Byte
    uint16_t CRC16;  // CRC          2Byte

} RIS_MotorData_t; //      16Byte

#pragma pack()

/// @brief ָṹ
typedef struct
{
    unsigned short id;   // ID15㲥ݰ
    unsigned short mode; // 0: 1:FOC 2:궨
    float T;             // ؽڵ()(Nm)
    float W;             // ؽٶ(ٶ)(rad/s)
    float Pos;           // ؽλ(rad)
    float K_P;           // ؽڸնϵ(0-25.599)
    float K_W;           // ؽٶϵ(0-25.599)


} GO_MotorCmd_t;

/// @brief ṹ
typedef struct
{
    unsigned char motor_id; // ID
    unsigned char mode;     // 0: 1:FOC 2:궨
    int Temp;               // ¶
    int MError;             // 
    float T;                // ǰʵʵ()(Nm)
    float W;                // ǰʵʵٶ(ٶ)(rad/s)
    float Pos;              // ǰλ(rad)
    int correct;            // Ƿ(10)
    int footForce;          // ԭʼֵ

    uint16_t calc_crc;
    uint32_t timeout;       // ͨѶʱ 
    uint32_t bad_msg;       // CRCУ 
    RIS_MotorData_t motor_recv_data; // ݽṹ

} GO_MotorData_t;

void modify_data(GO_MotorCmd_t *motor_s);
void extract_data(GO_MotorData_t *motor_r);
GO_MotorData_t *get_GO_measure_point(void);
void GO_M8010_send_data( GO_MotorCmd_t *cmd);
void USART6_RxCompleteCallback(void );





#endif /*__GO_M8010_6_H */
